diff --git a/script/trees b/script/trees
index 698d2b343f7..43cd39cc04f 100755
--- a/script/trees
+++ b/script/trees
@@ -2,7 +2,7 @@
 # SPDX-License-Identifier: GPL-3.0-or-later
 # Copyright (c) 2022-2023 Alper Nebi Yasak <alpernebiyasak@gmail.com>
 # Copyright (c) 2022 Ferass El Hafidi <vitali64pmemail@protonmail.com>
-# Copyright (c) 2023-2024 Leah Rowe <leah@libreboot.org>
+# Copyright (c) 2023-2025 Leah Rowe <leah@libreboot.org>
 
 set -u -e
 
@@ -11,10 +11,11 @@ set -u -e
 
 XBMKPATH="$PATH"
 
-eval `setvars "" xarch srcdir premake cmakedir xlang mode makeargs elfdir cmd \
+eval "`setvars "" xarch srcdir premake gnatdir xlang mode makeargs elfdir cmd \
     project target target_dir targets xtree _f release bootstrapargs mkhelper \
     autoconfargs listfile autogenargs btype tree rev tree_depend build_depend \
-    defconfig postmake mkhelpercfg dry dest_dir mdir cleanargs`; badhash="n"
+    defconfig postmake mkhelpercfg dry dest_dir mdir cleanargs gccver gccfull \
+    gnatver gnatfull gccdir cmakedir`"; badhash="n"
 
 main()
 {
@@ -52,7 +53,7 @@ main()
 	e "$mkhelpercfg" f missing && mkhelpercfg="$TMPDIR/mkhelper.cfg" && \
 	    x_ touch "$mkhelpercfg"
 
-	targets="$@"; cmd="build_targets $targets"
+	targets="$*"; cmd="build_targets $targets"
 	singletree "$project" && cmd="build_project"
 
 	remkdir "${tmpgit%/*}"
@@ -114,14 +115,15 @@ handle_defconfig()
 
 configure_project()
 {
-	eval `setvars "" xarch xlang build_depend autoconfargs xtree postmake \
+	eval "`setvars "" cleanargs build_depend autoconfargs xtree postmake \
 	    tree_depend makeargs btype mkhelper bootstrapargs premake release \
-	    cleanargs`
+	    xarch xlang`"
 	_tcfg="$1/target.cfg"; badhash="n"; [ -f "$_tcfg" ] || btype="auto"
-	[ -f "$datadir/mkhelper.cfg" ] && eval `setcfg "$datadir/mkhelper.cfg"`
+	[ -f "$datadir/mkhelper.cfg" ] && \
+	    eval "`setcfg "$datadir/mkhelper.cfg"`"
 
 	while [ -f "$_tcfg" ] || [ "$cmd" != "build_project" ]; do
-		eval `setvars "" rev tree`; eval `setcfg "$_tcfg"`
+		eval "`setvars "" rev tree`"; eval "`setcfg "$_tcfg"`"
 		printf "Loading %s config: %s\n" "$project" "$_tcfg"
 
 		[ "$_f" = "-d" ] && build_depend="" # dry run
@@ -139,7 +141,7 @@ configure_project()
 	[ -n "$tree" ] && mdir="$mdir/$tree"
 	[ -f "CHANGELOG" ] || check_project_hashes
 
-	[ "$mode" = "fetch" ] || x_ ./mk -f "$project" $target
+	[ "$mode" = "fetch" ] || x_ ./mk -f "$project" "$target"
 	[ "$mode" = "fetch" ] || return 0
 	[ -f "CHANGELOG" ] && return 1; fetch_${cmd#build_}; return 1
 }
@@ -197,7 +199,7 @@ check_cross_compiler()
 		[ "$project" != "coreboot" ] && cbdir="src/coreboot/default"
 		[ -n "$xtree" ] && cbdir="src/coreboot/$xtree"
 
-		x_ ./mk -f coreboot ${cbdir#src/coreboot/}
+		x_ ./mk -f coreboot "${cbdir#src/coreboot/}"
 
 		export PATH="$PWD/$cbdir/util/crossgcc/xgcc/bin:$PATH"
 		export CROSS_COMPILE="${xarch% *}-"
@@ -205,13 +207,72 @@ check_cross_compiler()
 
 		xfix="${_xarch%-*}" && [ "$xfix" = "x86_64" ] && xfix="x64"
 
+		# match gnat-X to gcc
+		check_gnu_path gcc gnat || check_gnu_path gnat gcc || \
+		    $err "Cannot match host GCC/GNAT versions"
+
 		# sometimes buildgcc fails for like no reason. try twice.
 		make -C "$cbdir" crossgcc-$xfix $xgccargs || \
 		    make -C "$cbdir" crossgcc-$xfix $xgccargs || \
 		    $err "!mkxgcc $project/$xtree '$xfix' '$xgccargs'"
+
+		# we only want to mess with hostcc to build xgcc
+		rm -f "$XBMK_CACHE/gnupath/"* || \
+		    $err "Cannot clear gnupath/"; :
 	done; return 0
 }
 
+# fix mismatching gcc/gnat versions on debian trixie/sid. as of december 2024,
+# trixie/sid had gnat-13 as gnat and gcc-14 as gcc, but has gnat-14 in apt. in
+# some cases, gcc 13+14 and gnat-13 are present; or gnat-14 and gcc-14, but
+# gnat in PATH never resolves to gnat-14, because gnat-14 was "experimental"
+check_gnu_path()
+{
+	[ $# -lt 2 ] && $err "check_gnu_path: Too few arguments"
+	[ "$1" = "$2" ] && $err "check_gnu_path: Both arguments identical"
+	for _gnuarg in 1 2; do
+		eval "[ \"\$$_gnuarg\" = \"gcc\" ] && continue"
+		eval "[ \"\$$_gnuarg\" = \"gnat\" ] && continue"
+		$err "check_gnu_path: Invalid argument \"$_gnuarg\""
+	done
+	command -v "$1" 1>/dev/null || $err "Host '$1' unavailable"
+
+	eval "`setvars "" gccver gccfull gnatver gnatfull gccdir gnatdir`"
+	gnu_setver "$1" "$1" || $err "Command '$1' unavailable."
+	gnu_setver "$2" "$2" || :
+
+	eval "[ -z \"\$$1ver\" ] && $err \"Cannot detect host '$1' version\""
+	[ "$gnatfull" = "$gccfull" ] && return 0
+
+	eval "$1dir=\"$(dirname "$(command -v "$1")")\""
+	eval "_gnudir=\"\$$1dir\"; _gnuver=\"\$$1ver\""
+	for _gnubin in "$_gnudir/$2-"*; do
+		[ -f "$_gnubin" ] || continue
+		[ "${_gnubin#"$_gnudir/$2-"}" = "$_gnuver" ] || continue
+		_gnuver="${_gnubin#"$_gnudir/$2-"}"; break
+	done
+	gnu_setver "$2" "$_gnudir/$2-$_gnuver" || return 1
+	[ "$gnatfull" = "$gccfull" ] || return 1
+
+	(
+	rm -f "$XBMK_CACHE/gnupath/"* || $err "Cannot clear gnupath/"
+	cd "$XBMK_CACHE/gnupath" || $err "Can't cd to gnupath/"
+	for _gnubin in "$_gnudir/$2"*"-$_gnuver"; do
+		[ -e "$_gnubin" ] || continue; _gnuutil="${_gnubin##*/}"
+		x_ ln -s "$_gnubin" "${_gnuutil%"-$_gnuver"}"
+	done
+	) || $err "Cannot create $2-$_gnuver link in $_gnudir"; :
+}
+
+gnu_setver()
+{
+	eval "$2 --version 1>/dev/null 2>/dev/null || return 1"
+	eval "$1ver=\"`"$2" --version 2>/dev/null | head -n1`\""
+	eval "$1ver=\"\${$1ver##* }\""
+	eval "$1full=\"\$$1ver\""
+	eval "$1ver=\"\${$1ver%%.*}\""; :
+}
+
 check_defconfig()
 {
 	[ -f "$defconfig" ] || $dry $err "$project/$target: missing defconfig"
@@ -243,7 +304,8 @@ handle_makefile()
 	    $dry x_ cp "$srcdir/$_copy" "$defconfig"
 
 	[ -e "$srcdir/.git" ] && [ "$project" = "u-boot" ] && \
-	    [ "$mode" = "distclean" ] && $dry x_ git -C "$srcdir" $cleanargs clean -fdx; :
+	    [ "$mode" = "distclean" ] && \
+		$dry x_ git -C "$srcdir" $cleanargs clean -fdx; :
 }
 
 run_make_command()
@@ -255,7 +317,7 @@ run_make_command()
 	$dry make -C "$srcdir" $mode -j$XBMK_THREADS $makeargs || $err "!$mode"
 	[ -z "$mkhelper" ] || [ -n "$mode" ] || $mkhelper || $err "!$mkhelper"
 
-	[ "$mode" = "clean" ] && \
+	[ "$mode" != "clean" ] || \
 	    $dry make -C "$srcdir" $cleanargs distclean || :; :
 }
 
@@ -291,6 +353,6 @@ copy_elf()
 	done < "$listfile"; x_ make clean -C "$srcdir" $cleanargs
 }
 
-main $@ || exit 0
+main "$@" || exit 0
 . "$mkhelpercfg"
 $cmd
diff --git a/util/nvmutil/AUTHORS b/util/nvmutil/AUTHORS
index f3c00385708..f38ea210a4d 100644
--- a/util/nvmutil/AUTHORS
+++ b/util/nvmutil/AUTHORS
@@ -1 +1,2 @@
 Leah Rowe
+Riku Viitanen
diff --git a/util/nvmutil/COPYING b/util/nvmutil/COPYING
index 784581dd40a..a6ecf2669b4 100644
--- a/util/nvmutil/COPYING
+++ b/util/nvmutil/COPYING
@@ -1,4 +1,5 @@
-Copyright (C) 2022, 2023 Leah Rowe <leah@libreboot.org>
+Copyright (C) 2022-2025 Leah Rowe <leah@libreboot.org>
+Copyright (c) 2023 Riku Viitanen <riku.viitanen@protonmail.com>
 
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
diff --git a/util/nvmutil/Makefile b/util/nvmutil/Makefile
index f25f6dd53e5..b8ec2ad395e 100644
--- a/util/nvmutil/Makefile
+++ b/util/nvmutil/Makefile
@@ -1,16 +1,24 @@
 # SPDX-License-Identifier: MIT
-# SPDX-FileCopyrightText: 2022 Leah Rowe <leah@libreboot.org>
+# SPDX-FileCopyrightText: 2022,2025 Leah Rowe <leah@libreboot.org>
 # SPDX-FileCopyrightText: 2023 Riku Viitanen <riku.viitanen@protonmail.com>
 
-CC=cc
-CFLAGS=-Os -Wall -Wextra -Werror -pedantic
-PREFIX?=/usr/bin
+CC?=cc
+CFLAGS?=-Os -Wall -Wextra -Werror -pedantic
+DESTDIR?=
+PREFIX?=/usr/local
+INSTALL?=install
 
 nvm: nvmutil.c
 	$(CC) $(CFLAGS) nvmutil.c -o nvm
 
-install: nvm
-	install nvm $(PREFIX)/nvm
+install:
+	$(INSTALL) nvm $(DESTDIR)$(PREFIX)/bin/nvm
+
+uninstall:
+	rm -f $(DESTDIR)$(PREFIX)/bin/nvm
+
+distclean:
+	rm -f nvm
 
 clean:
 	rm -f nvm
diff --git a/util/nvmutil/nvmutil.c b/util/nvmutil/nvmutil.c
index 35abbfae040..68bb95da40c 100644
--- a/util/nvmutil/nvmutil.c
+++ b/util/nvmutil/nvmutil.c
@@ -1,6 +1,6 @@
 /* SPDX-License-Identifier: MIT */
-/* SPDX-FileCopyrightText: 2022, 2023 Leah Rowe <leah@libreboot.org> */
-/* SPDX-FileCopyrightText: 2023 Riku Viitanen <riku.viitanen@protonmail.com> */
+/* Copyright (c) 2022-2025 Leah Rowe <leah@libreboot.org> */
+/* Copyright (c) 2023 Riku Viitanen <riku.viitanen@protonmail.com> */
 
 #include <sys/stat.h>
 
@@ -14,22 +14,23 @@
 #include <string.h>
 #include <unistd.h>
 
-void cmd_setchecksum(void), cmd_brick(void), cmd_copy(void), writeGbeFile(void),
-    cmd_dump(void), cmd_setmac(void), readGbeFile(void), showmac(int partnum),
-    hexdump(int partnum), handle_endianness(int partnum), openFiles(const char *path);
-int macAddress(const char *strMac, uint16_t *mac), validChecksum(int partnum);
+void cmd_setchecksum(void), cmd_brick(void), swap(int partnum), writeGbe(void),
+    cmd_dump(void), cmd_setmac(void), readGbe(void), cmd_copy(void),
+    macf(int partnum), hexdump(int partnum), openFiles(const char *path);
+int macAddress(const char *strMac, uint16_t *mac), goodChecksum(int partnum);
 uint8_t hextonum(char chs), rhex(void);
 
 #define COMMAND argv[2]
 #define MAC_ADDRESS argv[3]
-#define PARTNUM argv[3]
+#define PARTN argv[3]
 #define SIZE_4KB 0x1000
+#define NVM_CHECKSUM 0xBABA
 
 uint16_t buf16[SIZE_4KB], mac[3] = {0, 0, 0};
 uint8_t *buf = (uint8_t *) &buf16;
 size_t nf = 128, gbe[2];
-uint8_t nvmPartModified[2] = {0, 0}, skipread[2] = {0, 0};
-int e = 1, flags = O_RDWR, rfd, fd, part, gbeFileModified = 0;
+uint8_t nvmPartChanged[2] = {0, 0}, skipread[2] = {0, 0};
+int e = 1, flags = O_RDWR, rfd, fd, part, gbeFileChanged = 0;
 
 const char *strMac = NULL, *strRMac = "??:??:??:??:??:??", *filename = NULL;
 
@@ -41,7 +42,7 @@ typedef struct op {
 op_t op[] = {
 { .str = "dump", .cmd = cmd_dump, .args = 3},
 { .str = "setmac", .cmd = cmd_setmac, .args = 3},
-{ .str = "swap", .cmd = writeGbeFile, .args = 3},
+{ .str = "swap", .cmd = writeGbe, .args = 3},
 { .str = "copy", .cmd = cmd_copy, .args = 4},
 { .str = "brick", .cmd = cmd_brick, .args = 4},
 { .str = "setchecksum", .cmd = cmd_setchecksum, .args = 4},
@@ -56,13 +57,14 @@ void (*cmd)(void) = NULL;
     if (fstat(f, &st) == -1) err(ERR(), "%s", l)
 
 #define word(pos16, partnum) buf16[pos16 + (partnum << 11)]
-#define setWord(pos16, p, val16) if ((gbeFileModified = 1) && \
-    word(pos16, p) != val16) nvmPartModified[p] = 1 | (word(pos16, p) = val16)
+#define setWord(pos16, p, val16) if ((gbeFileChanged = 1) && \
+    word(pos16, p) != val16) nvmPartChanged[p] = 1 | (word(pos16, p) = val16)
 
 int
 main(int argc, char *argv[])
 {
 	if (argc < 3) {
+		fprintf(stderr, "Modify Intel GbE NVM images e.g. set MAC\n");
 		fprintf(stderr, "USAGE:\n");
 		fprintf(stderr, " %s FILE dump\n", argv[0]);
 		fprintf(stderr, " %s FILE setmac [MAC]\n", argv[0]);
@@ -76,9 +78,13 @@ main(int argc, char *argv[])
 	filename = argv[1];
 #ifdef __OpenBSD__
 	err_if(unveil("/dev/urandom", "r") == -1);
-	err_if(unveil(filename, flags == O_RDONLY ? "r" : "rw") == -1);
-	err_if(pledge(flags == O_RDONLY ? "stdio rpath" : "stdio rpath wpath",
-	    NULL) == -1);
+	if (flags == O_RDONLY) {
+		err_if(unveil(filename, "r") == -1);
+		err_if(pledge("stdio rpath", NULL) == -1);
+	} else {
+		err_if(unveil(filename, "rw") == -1);
+		err_if(pledge("stdio rpath wpath", NULL) == -1);
+	}
 #endif
 	openFiles(filename);
 #ifdef __OpenBSD__
@@ -92,15 +98,15 @@ main(int argc, char *argv[])
 	if (cmd == cmd_setmac)
 		strMac = (argc > 3) ? MAC_ADDRESS : strRMac;
 	else if ((cmd != NULL) && (argc > 3))
-		err_if((errno = (!((part = PARTNUM[0] - '0') == 0 || part == 1))
-		    || PARTNUM[1] ? EINVAL : errno));
+		err_if((errno = (!((part = PARTN[0] - '0') == 0 || part == 1))
+		    || PARTN[1] ? EINVAL : errno));
 	err_if((errno = (cmd == NULL) ? EINVAL : errno));
 
-	readGbeFile();
+	readGbe();
 	(*cmd)();
 
-	if ((gbeFileModified) && (flags != O_RDONLY) && (cmd != writeGbeFile))
-		writeGbeFile();
+	if ((gbeFileChanged) && (flags != O_RDONLY) && (cmd != writeGbe))
+		writeGbe();
 	err_if((errno != 0) && (cmd != cmd_dump));
 	return errno;
 }
@@ -117,9 +123,9 @@ openFiles(const char *path)
 }
 
 void
-readGbeFile(void)
+readGbe(void)
 {
-	nf = ((cmd == writeGbeFile) || (cmd == cmd_copy)) ? SIZE_4KB : nf;
+	nf = ((cmd == writeGbe) || (cmd == cmd_copy)) ? SIZE_4KB : nf;
 	skipread[part ^ 1] = (cmd == cmd_copy) | (cmd == cmd_setchecksum)
 	    | (cmd == cmd_brick);
 	gbe[1] = (gbe[0] = (size_t) buf) + SIZE_4KB;
@@ -127,7 +133,7 @@ readGbeFile(void)
 		if (skipread[p])
 			continue;
 		err_if(pread(fd, (uint8_t *) gbe[p], nf, p << 12) == -1);
-		handle_endianness(p);
+		swap(p);
 	}
 }
 
@@ -137,7 +143,7 @@ cmd_setmac(void)
 	if (macAddress(strMac, mac))
 		err(errno = ECANCELED, "Bad MAC address");
 	for (int partnum = 0; partnum < 2; partnum++) {
-		if (!validChecksum(part = partnum))
+		if (!goodChecksum(part = partnum))
 			continue;
 		for (int w = 0; w < 3; w++)
 			setWord(w, partnum, mac[w]);
@@ -193,16 +199,16 @@ void
 cmd_dump(void)
 {
 	for (int partnum = 0, numInvalid = 0; partnum < 2; partnum++) {
-		if (!validChecksum(partnum))
+		if (!goodChecksum(partnum))
 			++numInvalid;
 		printf("MAC (part %d): ", partnum);
-		showmac(partnum), hexdump(partnum);
+		macf(partnum), hexdump(partnum);
 		errno = ((numInvalid < 2) && (partnum)) ? 0 : errno;
 	}
 }
 
 void
-showmac(int partnum)
+macf(int partnum)
 {
 	for (int c = 0; c < 3; c++) {
 		uint16_t val16 = word(c, partnum);
@@ -215,10 +221,12 @@ void
 hexdump(int partnum)
 {
 	for (int row = 0; row < 8; row++) {
-		printf("%07x", row << 4);
+		printf("%08x ", row << 4);
 		for (int c = 0; c < 8; c++) {
 			uint16_t val16 = word((row << 3) + c, partnum);
-			printf(" %02x%02x", val16 >> 8, val16 & 0xff);
+			if (c == 4)
+				printf(" ");
+			printf(" %02x %02x", val16 & 0xff, val16 >> 8);
 		} printf("\n");
 	}
 }
@@ -229,43 +237,43 @@ cmd_setchecksum(void)
 	uint16_t val16 = 0;
 	for (int c = 0; c < 0x3F; c++)
 		val16 += word(c, part);
-	setWord(0x3F, part, 0xBABA - val16);
+	setWord(0x3F, part, NVM_CHECKSUM - val16);
 }
 
 void
 cmd_brick(void)
 {
-	if (validChecksum(part))
+	if (goodChecksum(part))
 		setWord(0x3F, part, ((word(0x3F, part)) ^ 0xFF));
 }
 
 void
 cmd_copy(void)
 {
-	if ((gbeFileModified = nvmPartModified[part ^ 1] = validChecksum(part)))
+	if ((gbeFileChanged = nvmPartChanged[part ^ 1] = goodChecksum(part)))
 		gbe[part ^ 1] = gbe[part]; /* speedhack: copy ptr, not words */
 }
 
 int
-validChecksum(int partnum)
+goodChecksum(int partnum)
 {
 	uint16_t total = 0;
 	for(int w = 0; w <= 0x3F; w++)
 		total += word(w, partnum);
-	if (total == 0xBABA)
+	if (total == NVM_CHECKSUM)
 		return 1;
 	fprintf(stderr, "WARNING: BAD checksum in part %d\n", partnum);
 	return (errno = ECANCELED) & 0;
 }
 
 void
-writeGbeFile(void)
+writeGbe(void)
 {
-	err_if((cmd == writeGbeFile) && !(validChecksum(0) || validChecksum(1)));
-	for (int p = 0, x = (cmd == writeGbeFile) ? 1 : 0; p < 2; p++) {
-		if ((!nvmPartModified[p]) && (cmd != writeGbeFile))
+	err_if((cmd == writeGbe) && !(goodChecksum(0) || goodChecksum(1)));
+	for (int p = 0, x = (cmd == writeGbe) ? 1 : 0; p < 2; p++) {
+		if ((!nvmPartChanged[p]) && (cmd != writeGbe))
 			continue;
-		handle_endianness(p^x);
+		swap(p^x);
 		err_if(pwrite(fd, (uint8_t *) gbe[p^x], nf, p << 12) == -1);
 	}
 	errno = 0;
@@ -273,9 +281,10 @@ writeGbeFile(void)
 }
 
 void
-handle_endianness(int partnum)
+swap(int partnum)
 {
+	size_t w, x;
 	uint8_t *n = (uint8_t *) gbe[partnum];
-	for (size_t w = nf * ((uint8_t *) &e)[0], x = 1; w < nf; w += 2, x += 2)
+	for (w = nf * ((uint8_t *) &e)[0], x = 1; w < nf; w += 2, x += 2)
 		n[w] ^= n[x], n[x] ^= n[w], n[w] ^= n[x];
 }
diff --git a/util/spkmodem_recv/Makefile b/util/spkmodem_recv/Makefile
index 1bba727c0d0..3c5dc51f6c2 100644
--- a/util/spkmodem_recv/Makefile
+++ b/util/spkmodem_recv/Makefile
@@ -1,8 +1,9 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
-CC ?= cc
-PREFIX  ?= /usr/local
-INSTALL ?= install
-CFLAGS ?= -Os -Wall -Wextra -Werror -pedantic
+CC?=cc
+CFLAGS?=-Os -Wall -Wextra -Werror -pedantic
+DESTDIR?=
+PREFIX?=/usr/local
+INSTALL?=install
 
 spkmodem-recv:
 	$(CC) $(CFLAGS) -o $@ $@.c
-- 
2.39.5

